#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);


#include "hand_OTA.h"

#define BUTTON_GPIO 14


void startCameraServer();

void setup() {

  pinMode(BUTTON_GPIO, INPUT_PULLUP); //2 GPIO - под кнопку обновления пошивки
  Serial.begin(115200);

  if (!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) // Address 0x3C for 128x64
    Serial.println(F("SSD1306 allocation failed"));
  display.clearDisplay();

  display.setTextSize(1);             // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE);        // Draw white text
  display.setCursor(0, 0);            // Start at top-left corner
  display.println(F("To update the firmware, press"));
  display.setCursor(0, 25);            // Start at top-left corner
  display.println(F("wait - 2 seconds"));
  display.display();
  Serial.setDebugOutput(false);
  for (int i = 0; i < 100; i++)
  {
    if (!digitalRead(BUTTON_GPIO)) //Если нажата кнопка
    {
      display.clearDisplay();
      display.setCursor(0, 0);            // Start at top-left corner
      display.print(F("Create a hotspot on your smartphone"));
      display.print(F(" with the name esp32point, "));
      display.print(F(" and password 12345678  ." ));
      display.print(F(" Activate this access point, "));
      display.display();
      delay(5000);
      display.print(F(" later press the button again!"));
      display.display();
      while(digitalRead(BUTTON_GPIO)) delay(10);//Ждем нового нажатия
      flag_OTA = true; //Переходим в режив обновления проошивки
      setup_OTA();
      return;
    }
    delay(20);
  }
  display.clearDisplay();
  display.setCursor(0, 25);
  display.println(F("normal program execution"));
  display.display();
  delay(200);
}

void loop() {
  if (!flag_OTA)
  {
    delay(1000);
  }
  else
  {
    server.handleClient();
    delay(100);
  }
}
